﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class michandler : MonoBehaviour
{

    private string device;
    private AudioClip clipRecord;
    private float[] avg;
    private int avgSize = 15;
    private int ix = 0;
    private float avgSum = 0;
    float min = 100f;
    float max = -1f;
    public float micLevel = 0;


    // Use this for initialization
    void Start()
    {
        if (device == null)
        {
            device = Microphone.devices[0];
        }
        clipRecord = Microphone.Start(device, true, 999, 44100);
        avg = new float[avgSize];
    }

    // Update is called once per frame
    void Update()
    {
        micLevel = getMicLevel();
    }

    public float getMicLevel()
    {
        int dec = 128;
        float[] waveData = new float[dec];
        int micPosition = Microphone.GetPosition(null) - (dec + 1); // null means the first microphone

        if (micPosition > 0)
        {
            clipRecord.GetData(waveData, micPosition);
            // Getting a peak on the last 128 samples
            float levelMax = 0;
            float wavePeak = 0;
            for (int i = 0; i < dec; i++)
            {
                wavePeak = waveData[i] * waveData[i];
                if (levelMax < wavePeak)
                {
                    levelMax = wavePeak;
                }
            }
            return levelMax;
        }
        else
        {
            return 0f;
        }
    }
}