﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BeamShootMovement : MonoBehaviour
{

    public playerHealth playerHealth;

    AudioSource audio;

    public AudioClip[] clips;

    public Server server;

    float angle_1 = 0.0f;

    float angle_2 = 0.0f;

    float old_angle_1 = 0.0f;
    float old_angle_2 = 0.0f;

    public Transform armJoint;
    public float moveSpeed = 5;
    private bool isFiring = false;
    public GameObject beam;
    private Animator animator;
    // Use this for initialization
    float angle = 0;
    void Start()
    {

        audio = GetComponent<AudioSource>();

        //Transform[] transArray = GetComponentsInChildren<Transform>();
        //foreach (Transform comp in transArray)
        //if (comp.tag == "Beam")
        //beam = comp;
        animator = GetComponentInParent<Animator>();
        if (animator != null)
            Debug.Log("I have an animator!");

        old_angle_1 = transform.rotation.eulerAngles.z;

        old_angle_2 = transform.rotation.eulerAngles.z;
    }

    // Update is called once per frame
    void Update()
    {
        //isFiring = false;
        if (transform.tag == "Player1")
        {
            ////not really angle, more like direction... 
            ////but it works with the keyboard
            //float angle = Input.GetAxis("Vertical1") * Time.deltaTime * moveSpeed;
            //if (angle != 0)
            //    Debug.Log("Rotating angle: " + angle + "shoulder pos: " + shoulderjoint);
            ////transform.rotation = Quaternion.Euler(transform.rotation.eulerAngles + new Vector3(0, 0, angle));
            //if((transform.rotation.eulerAngles.z > 20 && angle < 0) ||
            //    (transform.rotation.eulerAngles.z < 160 && angle > 0))
            //    transform.RotateAround(shoulderjoint.position, new Vector3(0,0,1), angle);
            if (server.playerFire_1 && playerHealth.currentScreamMeter > 0)
            //if(true)
            {
                isFiring = true;

                playerHealth.increaseScreamBar(-0.1f);

                audio.PlayOneShot(clips[0], 0.2f);
                Invoke("PlayBeamLoop", 0.19f);
            }
            else
            {
                isFiring = false;
                audio.Stop();
            }
            animator.SetBool("isAttacking", isFiring);


            if (server.playerMic_1 > 0.5 && !isFiring)
            {
                playerHealth.increaseScreamBar(1f);
            }


        }
        if (transform.tag == "Player2")
        {
            if (server.playerFire_2 && playerHealth.currentScreamMeter > 0)
            {
                isFiring = true;
                playerHealth.increaseScreamBar(-0.1f);

                audio.PlayOneShot(clips[0], 0.2F);
                Invoke("PlayBeamLoop", 0.19f);

            }
            else
            {
                isFiring = false;
                audio.Stop();
            }

            if (server.playerMic_2 > 0.5 && !isFiring)
            {
                playerHealth.increaseScreamBar(1);
            }

        }

        if (transform.tag == "Player1")
        {
            angle_1 = server.playerAngle_1 - old_angle_1;

            transform.RotateAround(armJoint.position, new Vector3(0, 0, 1), angle_1 - 4);

            old_angle_1 = transform.rotation.eulerAngles.z;
        }
        else if (transform.tag == "Player2")
        {
            angle_2 = server.playerAngle_2 - old_angle_2;

            transform.RotateAround(armJoint.position, new Vector3(0, 0, -1), angle_2 - 18);

            old_angle_2 = -transform.rotation.eulerAngles.z;
        }
        else
            Debug.LogWarning("Trying to move an untagged object.");

        if (isFiring && beam != null)
            beam.SetActive(true);
        else
            beam.SetActive(false);
    }

    void PlayBeamLoop()
    {
        audio.PlayOneShot(clips[1], 0.2f);
        audio.loop = true;
    }
}
