﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class TrapGhost : MonoBehaviour {

    public Transform cover;
    public float secondsToClose = 2.4f;
    public float closingSpeed = 40f;
    public int totalGhosts = 2;

    AudioSource audio;

    public AudioClip clip;

    void Start()
    {

        audio = GetComponent<AudioSource>();

    }

    void OnTriggerEnter(Collider col)
    {
        if (col.tag != "Ghost")
            return;

        GhostMovement ghostmov = col.gameObject.GetComponent<GhostMovement>();
        if (!(ghostmov.isHitByP1() && ghostmov.isHitByP2()))
            return;

        audio.PlayOneShot(clip, 0.5f);

        object[] isTrappedParameters = new object[1];
        isTrappedParameters[0] = secondsToClose;
        col.gameObject.SendMessage("GhostIsTrapped", isTrappedParameters);
        totalGhosts--;

        StartCoroutine(RotateCover(cover, Vector3.left, 0));
        StartCoroutine(RotateCover(cover, Vector3.right, secondsToClose + 1));
        if(totalGhosts == 0)
        {
            //gameover.enabled;

            Invoke("GameOver", 2f);
        }
    }

    void GameOver()
    {
        PlayerPrefs.SetInt("gameResult", 1);
        SceneManager.LoadScene("game-over");
    }

    IEnumerator RotateCover(Transform cover, Vector3 direction, float delay)
    {
        yield return new WaitForSeconds(delay);
        float closingTimer = secondsToClose;
        while (closingTimer > 0)     //While the time is more than zero...
        {
            cover.transform.RotateAround(cover.transform.position, direction, Time.deltaTime * closingSpeed);     //...rotate the object.
            closingTimer -= Time.deltaTime;     //Decrease the time- value one unit per second.

            yield return null;     //Loop the method.
        }
    }
    
}
