﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class playerHealth : MonoBehaviour
{
    int maxMeter = 100;
    int currentHealth = 100;
    public float currentScreamMeter = 50;
    bool damaged; // Maybe display animation if user takes damage
    float widthSize = 1.9f;
    float width = 0;

    public AudioClip clip;

    AudioSource audio;

    public Image healthSlider;
    public Image screamSlider;
    public bool isDead; // To define is user is dead
    public bool poweringUp; // To define if user is screaming/powering up
    public float secondsPerHealthDecrease = 2;
    private float healthDecreaseTimer;
    void Start () {
        calculateBar(currentHealth);
        updateHealthBar();

        calculateBar(currentScreamMeter);
        updateScreamBar();
        healthDecreaseTimer = secondsPerHealthDecrease;

        audio = GetComponent<AudioSource>();
    }

    

    void Update () {
        if (healthDecreaseTimer <= 0)
        {
            TakeDamage(1, false);
            healthDecreaseTimer = secondsPerHealthDecrease;
        }
        else
            healthDecreaseTimer -= Time.deltaTime;

        
        if (damaged) {
            // Display damage
        }
        else {
            // Undisplay damage
        }

        damaged = false;
    }

    void calculateBar (float x) {
        width = (x / 100) * widthSize;
    }

    void updateHealthBar() {
        RectTransform objectRectTransformHealth = healthSlider.GetComponent<RectTransform> ();
        objectRectTransformHealth.sizeDelta = new Vector2 (width, objectRectTransformHealth.sizeDelta.y);        
    }

    void updateScreamBar() {
        RectTransform objectRectTransformScream = screamSlider.GetComponent<RectTransform> ();
        objectRectTransformScream.sizeDelta = new Vector2 (width, objectRectTransformScream.sizeDelta.y);        
    }

    public void TakeDamage (int amount, bool isGhost) {

        if(isGhost)
            audio.PlayOneShot(clip, 0.5f);

        damaged = true;

        currentHealth -= amount;

        calculateBar(currentHealth);
        updateHealthBar();

        if(currentHealth <= 0 && !isDead) {
            Death();
        }
    }

    public void increaseScreamBar (float amount) {
        poweringUp = true;

        currentScreamMeter += amount;

        if (currentScreamMeter > maxMeter) {
            currentScreamMeter = maxMeter;
        }

        calculateBar(currentScreamMeter);
        updateScreamBar();
    }


    void Death () {
        isDead = true;
        SceneManager.LoadScene("game-over");
    }       
}